/*
 * This file has been generated by the onto2vocabularyclass tool
 * copyright (C) 2007-2008 Sebastian Trueg <trueg@kde.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _SOPRANO_NCTX_H_
#define _SOPRANO_NCTX_H_

#include <QtCore/QUrl>

namespace Nepomuk {
    namespace Vocabulary {
        namespace NCTX {
            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/
             */
            QUrl nctxNamespace();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx 
             */
            QUrl nctx();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#ActiveContexts 
             * 
             * Holds the current state consisting of all the current active 
             * contexts. 
             */
            QUrl ActiveContexts();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#ContextRepresentation 
             * 
             * Abstract base class for all contexts: UserContext or EnvironmentContext. 
             */
            QUrl ContextRepresentation();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#ContextSet 
             * 
             * Represents the state of the entire context system at one specific 
             * point in time. 
             */
            QUrl ContextSet();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#ContextualElement 
             * 
             * A contextual element represents the state of a resource (usually 
             * a pimo:thing) in the current work context. It is created when 
             * the resource in question enters the attention of the user, it 
             * is removed when this attention fades away. 
             * Every touched resource will be represented by one individual 
             * context element in a context thread, it will also be represented 
             * in another context element for the short term context, and another 
             * for the long term context. All three contextual elements may 
             * hold three different attention values for the same resource. 
             * No history of past values is kept. 
             */
            QUrl ContextualElement();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#EnvironmentContext 
             * 
             * Abstract base class for all environment dependant contexts: 
             * location, etc. Will be automatically set based on environmental 
             * setup 
             */
            QUrl EnvironmentContext();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#UserContext 
             * 
             * Abstract base class for all user dependant contexts: User Work 
             * Context, Context Filter, etc. Need to be set by the user 
             */
            QUrl UserContext();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#activeEnvironmentContext 
             * 
             * There can be multiple active environment work contexts. This 
             * is set automatically without user intervention. 
             */
            QUrl activeEnvironmentContext();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#activeUserContext 
             * 
             * There can be multiple active environment work contexts. This 
             * is set by the user 
             */
            QUrl activeUserContext();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#basedOnNativeOperation 
             * 
             * The native operation(s) which implied the creation of this 
             * CE. Range is Native Operations (NOP). Can be multiple, when 
             * multiple NOPs contribute to this CE. 
             */
            QUrl basedOnNativeOperation();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#belongsToContext 
             * 
             * A contextual element belongs to exactly one Context Thread 
             * and hence contributes to this contex thread. 
             */
            QUrl belongsToContext();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#containsElement 
             * 
             * Lists the elements in this thread. 
             */
            QUrl containsElement();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#currentAttentionValue 
             * 
             * The current attention value of the user towards this element. 
             * Expresses how much attention the user has given to the connected 
             * resource within the current context thread. This value is subject 
             * to change continually, it is dynamically computed by the ContextBoiler. 
             */
            QUrl currentAttentionValue();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#firstAccess 
             * 
             * the date-time when the resource was touched first. 
             */
            QUrl firstAccess();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#lastAccess 
             * 
             * The last date-time when the resource was touched. 
             */
            QUrl lastAccess();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#resource 
             * 
             * The resource that is in the attention of the user in this Context 
             * Thread. Mandatory. Typically, this points to PIMO concepts 
             * (subclasses or instances of pimo:Thing). Alternatively, 
             * this can also be information elements (files, etc) represented 
             * NIE or any other semantic web resources that receive attention 
             * by the user. 
             */
            QUrl resource();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx#subContextOf 
             * 
             * Allows to group contexts. An application can decide to only 
             * use the parent context or the specialization. Possible examples 
             * are: Nepomuk subContextOf KDE 
             */
            QUrl subContextOf();

            /**
             * http://nepomuk.kde.org/ontologies/2008/09/05/nctx/metadata 
             */
            QUrl metadata();
        }
    }
}

#endif
