/*
    Copyright (c) 2008 Sebastian Trueg <trueg@kde.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _NEPOMUK_ANNOTATION_DIALOG_H_
#define _NEPOMUK_ANNOTATION_DIALOG_H_

#include <KDialog>

#include <Nepomuk/Resource>

namespace Nepomuk {
    class AnnotationDialog : public KDialog
    {
        Q_OBJECT

    public:
        AnnotationDialog( QWidget* parent = 0 );
        ~AnnotationDialog();

        /**
         * Set the resource to annotate. If no resource is set
         * a new resource is created when the dialog is executed.
         */
        void setResource( const Nepomuk::Resource& );

        Nepomuk::Resource resource() const;

    private:
        class Private;
        Private* const d;

        Q_PRIVATE_SLOT( d, void _k_nameChangeTimeout() )
    };
}

#endif
