/* This file is part of the Nepomuk Project
   Copyright (c) 2008 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef _NEPOMUK_PIMO_SERVICE_H_
#define _NEPOMUK_PIMO_SERVICE_H_

#include <Nepomuk/Service>

#include <QtCore/QVariant>


namespace Nepomuk {

    class PimoModel;

    class PimoService : public Service
    {
        Q_OBJECT
        Q_CLASSINFO( "D-Bus Interface", "org.kde.nepomuk.Pimo" )

    public:
        /**
         * both paramters are basically unused but forced by the KDE
         * plugin system.
         */
        PimoService( QObject* parent, const QVariantList& );
        ~PimoService();

    private:
        PimoModel* m_pimoModel;
    };
}

#endif
