/* This file is part of the Nepomuk Project
   Copyright (c) 2008 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include "pimoserviceadaptor.h"
#include "pimoservice.h"
#include "pimomodel.h"

#include <QtCore/QString>
#include <QtCore/QUrl>


Nepomuk::PimoServiceAdaptor::PimoServiceAdaptor( Nepomuk::PimoService* parent, PimoModel* model )
    : QDBusAbstractAdaptor( parent ),
      m_model( model )
{
}


Nepomuk::PimoServiceAdaptor::~PimoServiceAdaptor()
{
}


QString Nepomuk::PimoServiceAdaptor::createClass( const QString& parent, const QString& label, const QString& comment, const QString& icon )
{
    return QString::fromAscii( m_model->createClass( QUrl::fromEncoded( parent.toAscii() ),
                                                     label,
                                                     comment,
                                                     icon ).toEncoded() );
}


QString Nepomuk::PimoServiceAdaptor::createProperty( const QString& domain, const QString& range, const QString& label, const QString& comment, const QString& icon )
{
    return QString::fromAscii( m_model->createProperty( QUrl::fromEncoded( domain.toAscii() ),
                                                        QUrl::fromEncoded( range.toAscii() ),
                                                        label,
                                                        comment,
                                                        icon ).toEncoded() );
}


QString Nepomuk::PimoServiceAdaptor::createThing( const QString& type, const QString& label, const QString& comment, const QString& icon )
{
    return QString::fromAscii( m_model->createThing( QUrl::fromEncoded( type.toAscii() ),
                                                     label,
                                                     comment,
                                                     icon ).toEncoded() );
}

#include "pimoserviceadaptor.moc"
